<template>
  <div class="doc">
    <div class="row">
      <div class="col-xs-3">
        <div class="row">
          <div class="col-xs-12">
            <ob-select
              v-model="doc.document_type_uuid"
              :items="docTypes"
              :disabled="disabledForm"
              display-exp="name"
              value-exp="uuid"
              :label="dictionaryRu.modal.documents.doc_form.document_type"
              :placeholder="dictionaryRu.modal.documents.doc_form.document_type_placeholder"
            />
          </div>
        </div>
        <div class="row">
          <div class="col-xs-12">
            <ob-select
              style="margin-bottom: 0"
              v-model="doc.creator"
              :items="CREATED_BY"
              display-exp="text"
              value-exp="value"
              :disabled="disabledForm"
              :placeholder="dictionaryRu.modal.documents.doc_form.created_by_placeholder"
              :label="dictionaryRu.modal.documents.doc_form.created_by"
            />
          </div>
        </div>
      </div>
      <div class="col-xs-3">
        <div class="title">{{dictionaryRu.modal.documents.doc_form.use_title}}</div>
        <ob-checkbox
          :value="getCheckUsedBy(USED_BY.client_expeditor)"
          :disabled="disabledForm"
          :label="dictionaryRu.modal.documents.doc_form.client_expeditor"
          property="client_expeditor"
          @change="onValueChanged($event, USED_BY.client_expeditor)"
        />
        <ob-checkbox
          :value="getCheckUsedBy(USED_BY.expeditor_carrier)"
          :disabled="disabledForm"
          :label="dictionaryRu.modal.documents.doc_form.expeditor_carrier"
          property="expeditor_carrier"
          @change="onValueChanged($event, USED_BY.expeditor_carrier)"
        />
        <ob-checkbox
          :value="getCheckUsedBy(USED_BY.client_carrier)"
          :disabled="disabledForm"
          :label="dictionaryRu.modal.documents.doc_form.client_carrier"
          property="expeditor_carrier"
          @change="onValueChanged($event, USED_BY.client_carrier)"
        />
      </div>
      <div class="col-xs-6">
        <div class="copies">
          <div class="title">
            {{ dictionaryRu.modal.documents.doc_form.document_count }} {{ docsCount }}) {{ dictionaryRu.modal.documents.doc_form.document_count_next }}</div>
          <div class="row">
            <div class="col-xs-11">
              <div class="row">
                <div class="col-xs-3">
                  <div
                    :property="'documents.' + vnodeKey + '.documents_numbers.Клиент'"
                    class="copies__item"
                  >
                    <ob-input
                      :label="dictionaryRu.modal.documents.doc_form.client"
                      type="number"
                      :disabled="!(doc.parties && doc.parties.length > 0) || disabledForm"
                      v-model="doc.client_count"
                    />
                  </div>
                </div>
                <div class="col-xs-3">
                  <div
                    :property="'documents.' + vnodeKey + '.documents_numbers.Грузополучатель'"
                    class="copies__item"
                  >
                    <ob-input
                      :label="dictionaryRu.modal.documents.doc_form.consignee"
                      type="number"
                      :disabled="!(doc.parties && doc.parties.length > 0) || disabledForm"
                      v-model="doc.gp_count"
                    />
                  </div>
                </div>
                <div class="col-xs-3">
                  <div
                    :property="'documents.' + vnodeKey + '.documents_numbers.Экспедитор'"
                    class="copies__item"
                  >
                    <ob-input
                      :label="dictionaryRu.modal.documents.doc_form.expeditor"
                      type="number"
                      :disabled="!(doc.parties && doc.parties.length > 0) || disabledForm"
                      v-model="doc.expeditor_count"
                    />
                  </div>
                </div>
                <div class="col-xs-3">
                  <div
                    :property="'documents.' + vnodeKey + '.documents_numbers.Поставщик'"
                    class="copies__item"
                  >
                    <ob-input
                      :label="dictionaryRu.modal.documents.doc_form.carrier"
                      type="number"
                      :disabled="!(doc.parties && doc.parties.length > 0) || disabledForm"
                      v-model="doc.carrier_count"
                    />
                  </div>
                </div>
              </div>
            </div>
            <div class="col-xs-1 close-col">
              <i
                class="icon close"
                :disabled="disabledForm"
                @click="remove(doc)"
              />
            </div>
          </div>
          <div class="row">
            <div class="col-xs-6">
              <div
                v-if="getCheckUsedBy(USED_BY.client_expeditor) || getCheckUsedBy(USED_BY.client_carrier)"
                class="title"
              >
                {{ dictionaryRu.modal.documents.doc_form.summary_client }} {{ doc.documents_numbers ? doc.documents_numbers['Клиент'] : '' }}
              </div>
            </div>
            <div class="col-xs-6">
              <div
                v-if="getCheckUsedBy(USED_BY.client_expeditor) || getCheckUsedBy(USED_BY.expeditor_carrier)"
                class="title"
              >
                {{ dictionaryRu.modal.documents.doc_form.summary_expeditor }} {{ doc.documents_numbers ? doc.documents_numbers['Экспедитор'] : '' }}
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import SERVICES_MIXIN from '@/mixins/enum/services';
import ObSelect       from 'common-components/src/obComponents/obSelect';
import ObCheckbox     from 'common-components/src/obComponents/obCheckbox';
import ObInput        from 'common-components/src/obComponents/obInput';
import { dictionary } from '@/translations/ru/dictionaries__services__service_types';

export default {
  name: "DocForm",
  components: {
    ObInput,
    ObCheckbox,
    ObSelect
  },
  props: {
    doc: {
      type: Object,
      default: () => {}
    },
    docTypes: {
      type: Array,
      default: () => []
    },
    disabledForm: {
      type: Boolean,
      default: true
    }
  },
  mixins: [SERVICES_MIXIN],
  data() {
    return {
      USED_BY: {
        client_expeditor : 'CLIENT_CLICAR',
        expeditor_carrier: 'CLICAR_CARRIER',
        client_carrier   : 'CLIENT_CARRIER'
      },
      dictionaryRu: dictionary
    };
  },
  computed: {
    docsCount() {
      let count = 0;
      for (let number in this.doc.documents_numbers) {
        count += parseInt(this.doc.documents_numbers[number]);
      }
      return count;
    },
    vnodeKey() {
      return this.$vnode && this.$vnode.key;
    }
  },
  methods: {
    getCheckUsedBy(key) {
      return this.doc.parties && this.doc.parties.indexOf(key) > -1;
    },
    onValueChanged(event, key) {
      if (!this.doc.parties) {
        this.doc.parties = [];
      }
      if (event) {
        this.doc.parties.push(key);
      } else {
        this.doc.parties = this.doc.parties.filter(item => {
          return item !== key;
        });
      }
    },
    inputDocNumber(event, key) {
      if (!this.doc.documents_numbers) {
        this.doc.documents_numbers = {};
      }
      this.$set(this.doc.documents_numbers, key, Number(event));
    },
    remove(doc) {
      if (!this.disabledForm) this.$emit('remove', doc.uuid);
    }
  }
};
</script>

<style lang="scss" scoped>
.close-col {
  align-self: center;

  & > i {
    cursor: pointer;
  }
}
.doc {
  border: 1px solid $lavender;
  border-radius: 3px;
  padding: 0 20px 0 20px;
}
.title {
  font-size: 11px;
  line-height: 12px;
  letter-spacing: 0.4px;
  text-transform: uppercase;
  font-variant: small-caps;
  color: $color-grey-span;
}
</style>
